
set serveroutput on
set echo on

DECLARE

   TYPE aat_binary IS TABLE OF VARCHAR2(10)
      INDEX BY BINARY_INTEGER;
   aa_binary aat_binary;

   TYPE aat_pls IS TABLE OF VARCHAR2(10)
      INDEX BY PLS_INTEGER;
   aa_pls aat_pls;

   v_dummy VARCHAR2(10);

BEGIN

   timer.snap;
   FOR i IN 1 .. 1000000 LOOP
      aa_binary(i) := RPAD('X',10);
   END LOOP;
   timer.show('Load BINARY');

   timer.snap;
   FOR i IN 1 .. 1000000 LOOP
      aa_pls(i) := RPAD('X',10);
   END LOOP;
   timer.show('Load PLS');

   timer.snap;
   FOR i IN 1 .. 1000000 LOOP
      v_dummy := aa_binary(i);
   END LOOP;
   timer.show('Access BINARY');

   timer.snap;
   FOR i IN 1 .. 1000000 LOOP
      v_dummy := aa_pls(i);
   END LOOP;
   timer.show('Access PLS');

END;
/


   
