
set echo on
set serveroutput on

DECLARE

   TYPE aat_days_in_month IS TABLE OF NUMBER
      INDEX BY VARCHAR2(30);

   aa_days aat_days_in_month;

   v_start DATE;
   v_indx  VARCHAR2(30);
   v_days  NUMBER;

BEGIN

   /* Looping assignment... */
   FOR i IN 0 .. 11 LOOP

      v_start := ADD_MONTHS(TRUNC(SYSDATE,'YEAR'),i);
      v_indx := TRIM(TO_CHAR(v_start,'MONTH'));
      v_days := EXTRACT(DAY FROM LAST_DAY(v_start));

      aa_days(v_indx) := v_days;

   END LOOP;

   /* Looping access... */
   v_indx := aa_days.FIRST;
   WHILE v_indx IS NOT NULL LOOP
      DBMS_OUTPUT.PUT_LINE(
         'Days in ' || v_indx || ' = ' || aa_days(v_indx)
         );
      v_indx := aa_days.NEXT(v_indx);
   END LOOP;

END;
/

