
set echo on
set serveroutput on

DECLARE

   TYPE aat_days_in_month IS TABLE OF NUMBER
      INDEX BY VARCHAR2(30);

   aa_days aat_days_in_month;

BEGIN

   /* Literal assignments... */
   aa_days('JANUARY') := 31;
   aa_days('FEBRUARY') := EXTRACT(DAY FROM LAST_DAY(ADD_MONTHS(TRUNC(SYSDATE,'YEAR'),1)));
   -- and so on --
   aa_days('DECEMBER') := 31;

   /* Literal access... */
   DBMS_OUTPUT.PUT_LINE(
      'There are ' || aa_days('FEBRUARY') || ' days in February this year.'
      );

END;
/

