
set echo on

DROP TABLE lookup_table;

CREATE TABLE lookup_table
CACHE
AS
   SELECT owner || '.' || table_name AS primary_key
   ,      DBMS_RANDOM.STRING('u',50) AS description
   FROM   all_tables;

ALTER TABLE lookup_table ADD (
   CONSTRAINT lookup_table_pk
   PRIMARY KEY (primary_key)
   );

exec DBMS_STATS.GATHER_TABLE_STATS(USER,'LOOKUP_TABLE',cascade=>TRUE);

SELECT COUNT(*) FROM lookup_table;
