set echo on
set serveroutput on size 100000

exec runstats_pkg.rs_start;

DECLARE
   v_description lookup_table.description%TYPE;
BEGIN
   FOR r IN (SELECT primary_key AS key
             FROM   lookup_table
             ,     (SELECT ROWNUM FROM dual CONNECT BY ROWNUM <= 100))
   LOOP
      v_description := lookup_pkg.array_lookup(r.key);
   END LOOP;
END;
/

exec runstats_pkg.rs_middle;

DECLARE
   v_description lookup_table.description%TYPE;
BEGIN
   FOR r IN (SELECT primary_key AS key
             FROM   lookup_table
             ,     (SELECT ROWNUM FROM dual CONNECT BY ROWNUM <= 100))
   LOOP
      v_description := lookup_pkg.table_lookup(r.key);
   END LOOP;
END;
/

exec runstats_pkg.rs_stop(1000);

